--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--
-------o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o-------
--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

if wdwMod_Info == nil then wdwMod_Info = {} end 
if wdwMod_Rotations == nil then wdwMod_Rotations = {} end

local burnTimer, minMana, power, haste, amQueued, btStart, train = 15, 0.5, 0, 0, false, 0, "y"

local abs = math.abs

local function AddToQueue(spellItemID, direction, expires)

	-- Will insert a spell/item at the first available location, starting from the left-most position consistent with any remaining CD/expiry

	-- spellItemID	:		the spell/item to queue
	-- direction	:		Direction to look for space in the queue. Optional. +1 is the default. -1 will cause a seek leftwards
	-- expires	:		the remaining CD or time to expiry (optional). If nil then calculates

	-- return codes:	0  = no space
	--			n  = queue location

	direction = direction or 1
	if direction ~= 1 then direction = -1 end
	local cdLeft = expires or WeDontWipe:CooldownLeft(spellItemID)

	local pos = floor(( cdLeft - wdw_GCD) / wdw_GCDtop) + 1
	if pos < 1 then pos = 1 end
	if pos > wdw_maxQueueLength then return 0 end

	local savedPos = pos
	while wdw_Queue[pos] ~= 0 do
		pos = pos + direction
		if pos > wdw_maxQueueLength then return 0 end
		if pos == 0 then
			pos = savedPos
			direction = 1
		end
	end

	wdw_Queue[pos] = spellItemID
	return pos
end

--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--
-------o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o-------
--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

wdwMod_Info["Taraezor@Frostmourne MageArcane"] = {

	["Class"] = "Mage",
	["Specialisation"] = "Arcane",
	["Version"] = "2.01 for Patch 6.0.3",
	["Author"] = "Taraezor@Frostmourne",
	["Template"] = "1.01",
--	["Sound"] = "Sound/Doodad/Fx_Owl05.ogg", -- Owl sfx. Quiet and inoffensive
	["Sound"] = "Sound/Spells/Shaysbell.ogg",

	["Interrupt"] = { 2139,8,},			-- Counterspell
	["Purge"] =	{ 30449,64,"Magic",},		-- Spellsteal
	["Cleanse"] =   { 475,29,"Curse"},		-- Remove Curse

	["Cooldown"] = {12051,40,12042,62,55342,90,45438,26,66,56}, -- spellID,level,...
	-- Arcane Power,Alter Time,Mirror Images,Time Warp,Ice Block,Invisibility
}

wdwMod_Rotations["Taraezor@Frostmourne MageArcane"] = {

	["Rotations"] = {

		["Single"] = {

			["Buffs"] = {"Brill",},
			["Rotation"] = {"Setup","ArcanePower","Crystal","Evocate","SuperNova","NethTemp","Orb","PoM","Tier 6","ArcMiss1","ArcBlast1","ArcMiss2","ArcBarr","Final"},
			["Special"] = {"Special"},
			["Notes"] = "Ready for Warlords of Draenor"
		},

	},

	["Special"] = function ()

		if wdw_specialModuleNew then
			if WeDontWipeDB[wdw_currentSpec]["specialModule"]["burntimer"] then
				burnTimer = tonumber(WeDontWipeDB[wdw_currentSpec]["specialModule"]["burntimer"])
			else
				WeDontWipeDB[wdw_currentSpec]["specialModule"]["burntimer"] = 15
			end
			if WeDontWipeDB[wdw_currentSpec]["specialModule"]["minmana"] then
				minMana = tonumber(WeDontWipeDB[wdw_currentSpec]["specialModule"]["minmana"])

				if minMana > 0 and minMana < 0.0099 then
					minMana = 0.5
					WeDontWipeDB[wdw_currentSpec]["specialModule"]["minmana"] = 0.5
					wdwWarning("Minimum Mana bug fixed by reverting to the 0.5 default")
				end

			else
				WeDontWipeDB[wdw_currentSpec]["specialModule"]["minmana"] = 0.5
			end
			if WeDontWipeDB[wdw_currentSpec]["specialModule"]["train"] then
				train = WeDontWipeDB[wdw_currentSpec]["specialModule"]["train"]
				if not ((train == "y") or (train == "n")) then
					train = "y"
					WeDontWipeDB[wdw_currentSpec]["specialModule"]["train"] = "y"
				end
			else
				WeDontWipeDB[wdw_currentSpec]["specialModule"]["train"] = "y"
			end
			wdwPrint(wdw_colour_MalachiteGreen.."WDW Arcane Mage parameters:")
			wdwPrint(wdw_colour_MalachiteGreen.."burntimer".. wdw_colour_Jasmine.."= ".. wdw_colour_SelectiveYellow ..burnTimer..
				wdw_colour_Jasmine.."s\n(Start BURN when remaining Evo CD is < this)")
			wdwPrint(wdw_colour_MalachiteGreen.."".. wdw_colour_Jasmine.."= ".. wdw_colour_SelectiveYellow..minMana..
				wdw_colour_Jasmine.."\n(Try to queue Evo when mana below "..minMana.." of max.)")
			wdwPrint(wdw_colour_MalachiteGreen.."train".. wdw_colour_Jasmine.."= ".. wdw_colour_SelectiveYellow ..train..
				wdw_colour_Jasmine.." (y or n)\n(burntimer will learn your actual BURN time)")
			wdw_specialModuleNew = false
		end
	end,

	["Brill"] = function () -- Dalaran and Arcane Brilliance. Levels 80 & 58

		if wdw_playerLevel < 58 then return end

		if (wdw_playerLevel < 80) or not WeDontWipe:HasCanShow(61316) then		-- Check for Dalaran Brilliance

			if not WeDontWipe:HasCanShow(1459) then return end

			if wdw_buffsPlayer["1459"] then
				AddToQueue(1459,-1,wdw_buffsPlayer["1459"].expires)
			elseif wdw_buffsPlayer["61316"] then
				AddToQueue(1459,-1,wdw_buffsPlayer["61316"].expires)
			else
				AddToQueue(1459)
			end
		else
			if wdw_buffsPlayer["1459"] then
				AddToQueue(61316,-1,wdw_buffsPlayer["1459"].expires)
			elseif wdw_buffsPlayer["61316"] then
				AddToQueue(61316,-1,wdw_buffsPlayer["61316"].expires)
			else
				AddToQueue(61316)
			end
		end
	end,

	["Setup"] = function ()

		amQueued = false

		-- Need to establish a phase. Based mostly upon mana levels and where the Evocation CD is at
		-- Default is to burn baby burn
		-- Timing assumption: at AC==4, ABlast costs 10% mana. If about 100% then = 5 x ABlasts to get down to about 50%
		-- Unhastened 2.2s casting time plus 1.5s GCD. Therefore allow for FIVE ABlasts = about 15s (plus some other stuff cast)
		-- See burnTimer local at the top

		cdEvo = 0
		if wdw_playerLevel >= 40 then -- i.e. has Evo
			cdEvo = WeDontWipe:CooldownLeft(12051)			-- Evocation
		end

		-- So cdEvo > 0 and cdEvo < burnTimer == burn phase. cdEvo == 0 is Evocation phase. cdEvo > burnTimer = build/conserve phase
		-- burn stops when mana < minMana

		power = wdw_power / wdw_powerMax
		haste = 1.5 / wdw_GCDtop

		if power == 1 then
			btStart = GetTime()
		end
	end,

	["ArcanePower"] = function ()	-- Arcane Power. Level 62 Cooldown. 90s CD for 15s buff. Off GCD

		if wdw_buffsPlayer["12051"] then return end			-- Evocate buff. REPLENISH Phase already commenced

		if wdw_playerLevel < 62 then return end
		if not WeDontWipe:HasCanShow(12042) then return end

		local cdAP = 90
		if wdw_hasGlyph["62210"] then cdAP = 180 end			-- Glyph of Arcane Power

		-- Online guides say: save for the BURN Phase. Which we are doing. But... if we can sneak an extra in then why not!
		-- Strictly speaking we are compensating for bad play here

		if cdEvo > cdAP then
			AddToQueue(12042)
		elseif cdEvo < burnTimer then					-- BURN Phase
			AddToQueue(12042)
		end
	end,

	["Crystal"] = function ()	-- Prismatic Crystal. Level 100 talent. 90s CD for 12s up time. GCD

		if cdEvo >= burnTimer then return end				-- CONSERVE Phase
		if wdw_buffsPlayer["12051"] then return end			-- Evocate buff. REPLENISH Phase already commenced

		if wdw_playerLevel < 100 then return end
		if not WeDontWipe:HasCanShow(152087) then return end

		AddToQueue(152087)
	end,

	["Evocate"] = function ()	-- Evocation. Level 40 ability with a 120s/90s CD, 6s/haste channelled up time and a GCD

		-- REPLENISH + Preliminaries (defined here as mana 25% higher than the set minimum)

		if wdw_playerLevel < 40 then return end
		if not WeDontWipe:HasCanShow(12051) then return end

		if wdw_buffsPlayer["12051"] then				-- Evocate buff. REPLENISH Phase already commenced
			AddToQueue(12051,1,0)
			return
		end

		if power > (minMana + 0.25) then return end

		-- To here if mana is no more than minMana (e.g.. 50%) + 25% = 75% of maximum mana AND not (yet) Evocating
		-- In other words we are BURN Phase and setting up for REPLENISH Phase

		-- Don't let any Arcane Missiles charges expire!

		if WeDontWipe:HasCanShow(5143) then				-- Arcane Missiles
			if wdw_buffsPlayer["79683"] then			-- Arcane Missiles Buff
				if wdw_buffsPlayer["79683"].expires < (cdEvo + 6/haste) then
					for i = 1, wdw_buffsPlayer["79683"].count do
						if AddToQueue(5143,-1,wdw_buffsPlayer["79683"].expires) > 0 then
							amQueued = true
						end
					end
				end
			end
		end

		-- Now place Evo at fixed places in the queue as we burn mana down. Player can see the CD on Evo and should adjust the burn
		-- At mana == minMana (e.g. 50%) then queue Evo normally. It *should* automatically be in queue position #1

		-- If Evo has any appreciable remaining CD then the player stuffed up lol

		if power > (minMana + 0.2) then
			if cdEvo <= wdw_GCD + 3 * wdw_GCDtop then
				AddToQueue(12051,1,(wdw_GCD + 3 * wdw_GCDtop))	-- Pos #4
			else
				AddToQueue(12051,1,cdEvo)
			end
		elseif power > (minMana + 0.1) then
			if cdEvo <= wdw_GCD + 2 * wdw_GCDtop then
				AddToQueue(12051,1,(wdw_GCD + 2 * wdw_GCDtop))	-- Pos #3
			else
				AddToQueue(12051,1,cdEvo)
			end
		elseif power > minMana then
			if cdEvo <= wdw_GCD + wdw_GCDtop then
				AddToQueue(12051,1,(wdw_GCD + wdw_GCDtop))	-- Pos #2
			else
				AddToQueue(12051,1,cdEvo)
			end
		else
			local pos = AddToQueue(12051,1,cdEvo)			-- Pos #1 (it should be)
			if btStart ~= 0 then
				wdwDebug("It took ".. wdw_colour_SelectiveYellow..wdwRound(GetTime()-btStart,2).. wdw_colour_BrandeisBlue..
					"s to deplete mana to "..minMana.." of max.","bt")
				if train == "y" then
					local oldTimer = burnTimer
					burnTimer = wdwRound(abs((burnTimer + GetTime()-btStart)/2),2)
					wdwDebug("Burn timer adjusted from "..oldTimer.."s to ".. wdw_colour_SelectiveYellow..burnTimer..
						wdw_colour_BrandeisBlue.."s","bt")
					WeDontWipeDB[wdw_currentSpec]["specialModule"]["burntimer"] = burnTimer
				end
			end
			btStart = 0

			if pos == 0 then 
				wdwWarning("Mana below "..minMana.." of max. but Evocation not ready")
				wdwPrint("Adjust timer with '/wdw sm burntimer=nn'\nCurrently burntimer="..
					wdw_colour_MalachiteGreen..burnTimer.. wdw_colour_Jasmine.."s. Try a lower value")
				wdwPrint("Or adjust Min. Mana ratio with 'wdw sm minmana=nn'\nCurrently minmana="..
					wdw_colour_MalachiteGreen..(minMana))
			end
		end
	end,

	["SuperNova"] = function () -- Super Nova. Tier 5 (level 75)

		-- Supernova is used soon after Arcane Power and Prismatic Crystal at the start of the Burn Phase
		-- Outside of this cast when mana < 94%, < 3xAM, and 2xSupernova sure to be ready for the Burn Phase usage

		if wdw_playerLevel < 75 then return end
		if not wdw_hasTalent["15"] then return end
		if not WeDontWipe:HasCanShow(122) then return end		-- Frost Nova for Super Nova (Still works if player excludes the Super Nova icon)

		local charges,_,start,duration = GetSpellCharges(157980)	-- Supernova

		if cdEvo < burnTimer then

			-- That's the criteria for the BURN phase. Do just that with Supernova
			-- While burning with Supernova, to hell if already at the 3xAM cap as we (should) have Arcane Power / Prismatic Crystal up!

			if charges > 0 then
				if charges > 1 then
					AddToQueue(122)
				end
				AddToQueue(122)
			end

		elseif not wdw_buffsPlayer["12051"] then			-- Evo buff = REPLENISH Phase

			-- We are in the CONSERVE Phase

			if wdw_buffsPlayer["79683"] then			-- Arcane Missiles
				if wdw_buffsPlayer["79683"] == 3 then return end
			end

			if power > 0.94 then return end				-- We'll max mana while doing the SN

			-- MUST have 2xSN ready for AP in the Burn Phase

			local apReady = WeDontWipe:CooldownLeft(12042)		-- Arcane Power. 90s CD. Must have 2xSN ready for it in the Burn
			local ready = start + duration - GetTime()		-- Supernova ready

			if charges == 0 then

				-- we need to wait 'ready' seconds for 1 charge + 'duration' for each other charge
				-- so we queue for a supernova providing total waiting time is before AP is ready

				if ready + 2*duration > apReady then return end
				AddToQueue(122,1,ready)

			elseif charges == 1 then

				if ready + duration > apReady then return end
				AddToQueue(122,1,0)
				if ready + 2*duration > apReady then return end
				AddToQueue(122,1,ready)

			elseif charges == 2 then

				if duration > apReady then return end
				AddToQueue(122,1,0)
				if 2*duration > apReady then return end
				AddToQueue(122,1, duration)
			end
		end
	end,

	["NethTemp"] = function () -- Nether Tempest (114923). Tier 5 (level 75). A DoT for Arcane Mages!

		-- Should be kept up so check buff expiry. <3.6s recommended. Optimal with 4xAC

		if wdw_playerLevel < 75 then return end
		if not WeDontWipe:HasCanShow(125430) then return end		-- Nether Tempest uses the Mage Bomb Spell ID
		if wdw_buffsPlayer["12051"] then return end			-- REPLENISH Phase

		if wdw_charges == 4 then --- four stack of Arcane Charges
			if wdw_debuffsTarget["114923"] then
				if wdw_debuffsTarget["114923"].expires < 3.6 then
					if AddToQueue(125430,1,0) then
						ntRequested = true
					end
				else
					if AddToQueue(125430,1,wdw_debuffsTarget["114923"].expires) then
						ntRequested = true
					end
				end
			else
				if AddToQueue(125430,1,0) then
					ntRequested = true
				end
			end
		end
	end,

	["Orb"] = function () -- Arcane Orb. Tier 7 (level 100)

		if wdw_playerLevel < 100 then return end
		if not WeDontWipe:HasCanShow(153626) then return end
		if wdw_buffsPlayer["12051"] then return end			-- REPLENISH Phase

		if wdw_charges < 2 then
			AddToQueue(153626)
		end
	end,

	["PoM"] = function () -- Presence of Mind - next spell is instant. Always use off CD. Level 22

		if wdw_playerLevel < 22 then return end
		if not WeDontWipe:HasCanShow(12043) then return end
		if wdw_buffsPlayer["12051"] then return end			-- REPLENISH Phase

		if not wdw_buffsPlayer["12043"] then
			AddToQueue(12043)
		end
	end,

	["Tier 6"] = function () -- Level 90

		-- Rune of Power is left up to the player at this stage

		if wdw_playerLevel < 90 then return end
		if not WeDontWipe:HasCanShow(55342) then return end		-- Mirror Image
		if wdw_buffsPlayer["12051"] then return end			-- REPLENISH Phase

		AddToQueue(55342)
	end,

	["ArcMiss1"] = function () -- Arcane Missiles. Level 24

		if wdw_playerLevel < 24 then return end
		if not WeDontWipe:HasCanShow(5143) then return end		-- Arcane Missiles
		if wdw_buffsPlayer["12051"] then return end			-- REPLENISH Phase

		if wdw_buffsPlayer["79683"] and not amQueued then		-- Arcane Missiles Buff
			if wdw_buffsPlayer["79683"].count == 3 then
				if AddToQueue(5143,1,0) then
					amQueued = true
				end
			else
				if AddToQueue(5143,-1,wdw_buffsPlayer["79683"].expires) > 0 then
					if wdw_buffsPlayer["79683"].count == 2 then
						if AddToQueue(5143,-1,wdw_buffsPlayer["79683"].expires) then
							amQueued = true
						end
					end
				end
			end
		end
	end,

	["ArcBlast1"] = function () -- Arcane Blast (30451). Level 10. Replaces Frostfire Bolt (44614) at level 10

		if wdw_playerLevel < 10 then return end
		if not WeDontWipe:HasCanShow(44614) then return end		-- Arcane Blast rename of FFB
		if wdw_buffsPlayer["12051"] then return end			-- REPLENISH Phase

		-- If BURN Phase then this is the filler

		if cdEvo < burnTimer then
			for i=1,wdw_queueLength do
				if wdw_Queue[i] == 0 then wdw_Queue[i] = 44614 end
			end
			return
		end

		-- To here if CONSERVE Phase
		-- WoD removed Spell cost from the API but for AB it is easy: 2% of max Mana + (number of AC charges) * 2%

		if power <= 0.93 then return end				-- Apparently we should do this. Simcrafted much?

		AddToQueue(44614)
	end,

	["ArcMiss2"] = function () -- Arcane Missiles. Level 24

		if wdw_playerLevel < 24 then return end
		if not WeDontWipe:HasCanShow(5143) then return end		-- Arcane Missiles
		if cdEvo < burnTimer then return end				-- Not CONSERVE Phase, so leave

		if wdw_buffsPlayer["79683"] and not amQueued and wdw_charges > 3 then		-- Arcane Missiles Buff
			AddToQueue(5143,1,0)
		end
	end,

	["ArcBarr"] = function () -- Arcane Barrage (44425). Level 12. Replaces Fire Blast (2136) at level 12

		if wdw_playerLevel < 12 then return end
		if not WeDontWipe:HasCanShow(2136) then return end		-- Arcane Barrage rename of Fire Blast
		if cdEvo < burnTimer then return end				-- Not CONSERVE Phase, so leave

		if (wdw_charges >= 4) and (cdEvo > 8) then
			AddToQueue(2136)
		end
	end,

	["Final"] = function () -- Arcane Blast from level 10 or Frostfire Bolt

		if wdw_playerLevel < 10 then return end
		if not WeDontWipe:HasCanShow(44614) then return end		-- Arcane Blast rename of FFB
		if cdEvo < burnTimer then return end				-- Not CONSERVE Phase, so leave

		-- Blizzard from WoD continue to use the same Spell ID as the player levels so keep it simple here. AddOn will work regardless

		for i=1,wdw_queueLength do
			if wdw_Queue[i] == 0 then wdw_Queue[i] = 44614 end
		end
	end,
}